<?php 
/**
 * @package    Proxim
 * @author     Davison Pro <davis@davisonpro.dev | https://davisonpro.dev>
 * @copyright  2020 Proxim
 * @version    1.0
 * @since      File available since Release 1.0
*/

namespace Proxim\Presenter\Order;

use Exception;
use Proxim\Order\Rating;
use Proxim\Presenter\PresenterInterface;

class OrderRatingPresenter implements PresenterInterface
{
    /**
     * @param Rating $order
     *
     * @return OrderRatingLazyArray
     *
     * @throws Exception
     */
    public function present($rating)
    {
        if (!($rating instanceof Rating)) {
            throw new Exception('OrderRatingPresenter can only present instance of Rating');
        }

        return new OrderRatingLazyArray($rating);
    }
}