<?php
/**
 * @package    Proxim
 * @author     Davison Pro <davisonpro.coder@gmail.com | https://davisonpro.dev>
 * @copyright  2019 Proxim
 * @version    1.0.0
 * @since      File available since Release 1.0.0
 */

namespace Proxim\Slim;

use Slim\Middleware;

class HttpCacheMiddleware extends Middleware
{
    public function call()
    {
        // NOTE: This is a hotfix to prevent ALL get param from being cached
        // This will be temporary until we implement our final cache layer/solution
        if ($this->app->request()->isGet()) {
            $response = $this->app->response();
            $response->header('Cache-Control', 'no-store,no-cache,must-revalidate');
        }

        $this->next->call();
    }
}
