<?php
/**
 * @package    Proxim
 * @author     Davison Pro <davisonpro.coder@gmail.com | https://davisonpro.dev>
 * @copyright  2019 Proxim
 * @version    1.0.0
 * @since      File available since Release 1.0.0
 */

require_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'prox-bootstrap.php';

$smarty = $app->container->smarty;

use Proxim\Tools;
use Proxim\Util\ArrayUtils;

$templateVars = array(
    'page' => [
        'title' => 'Place a New Inquiry',
        'description' => 'Place a New Inquiry'
    ],
    'app' => 'standalone-form',
    'orderformPurpose' => 'newInquiry',
    'target' => 'order',
);

$cookie = $app->container->cookie;

$defaultCountry = array();
if ( $cookie->country_code ) {
    $countries = $globals['countries'];
    $country_code = Tools::strtolower($cookie->country_code);

    if ( ArrayUtils::has($countries, $country_code) ) {
        $country = ArrayUtils::get($countries, $country_code);
        $defaultCountry = array(
            "id" => $country_code,
            "name" => ArrayUtils::get($country, 'name'),
            "code" => ArrayUtils::get($country, 'code'),
            "phoneCode" => ArrayUtils::get($country, 'phoneCode')
        );
    }
}

$templateVars = array_merge($templateVars, $defaultCountry);

$app->setVars($templateVars);

$app->setTemplate('inquiry');
$app->display();