<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <title>{$siteName} ChatBot</title>
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=2.0, viewport-fit=cover">
        <link rel="stylesheet" href="{$base_uri}/prox-modules/chatbot/css/main.css?ver={$system_version}" type="text/css"/>
        <link rel="stylesheet" href="{$base_uri}/prox-modules/chatbot/css/chatbot.css?ver={$system_version}" type="text/css"/>
    </head>
<body>

    <div class="chb-first-screen js_chatbot_container">
        <header class="chb-first-screen__header">
            <div class="container">
                <a href="{$base_uri}" class="chb-first-screen__header-logo">
                    <img src="{$siteLogo}" alt="logo" class="chb-first-screen__header-img">
                </a>
            </div>
        </header>
        <div class="chb-first-screen__chat-wrap">
            <section class="chb-window">
                <div class="chb-window__body">
                    <div class="chb-dropzone-popup js_chatbot_field_wrap js-dz-popup">
                        <div class="chb-dropzone-popup__body">
                            <div class="chb-dropzone-popup__dz-area b-form-group">
                                <div class="b-form-group__file-dropzone b-form-group__file-dropzone_chb">
                                    <div class="b-form-group__chb-textarea-wrap js_chatbot_description_wrap">
                                        <textarea name="chatbot[description]" class="b-form-group__textarea b-form-group__textarea_chb js-dz-popup-description" placeholder="Type your instructions here"></textarea>
                                    </div>
                                    <div class="b-form-group__chb-dropzone-previews-wrap">
                                        <span class="b-form-group__chb-dropzone-previews dropzone-previews js_chatbot_previews attached"></span>
                                        <div class="errorText js_chatbot_additional_materials_error"></div>
                                    </div>
                                </div>
                            </div>
                            <div class="chb-dropzone-popup__dz-controls">
                                <div class="chb-dropzone-popup__btn-col co-dropzone js_chatbot_select_file"></div>
                                <div class="chb-dropzone-popup__btn-col">
                                    <button type="button" class="chb-dropzone-popup__btn js-dz-popup-close">
                                        Done
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="chb-dialog">
                        <div class="chb-dialog__msgs-wrap js-chb-msgs-area">
                        </div>
                        <div class="chb-dialog__actions-wrap js-chb-actions">
                            <form class="chb-send-panel js-chb-msg-form" autocomplete="off">
                                <fieldset class="chb-send-panel__input-area js-chb-input-area">
                                    <div class="chb-send-panel__loader-container">
                                        <div class="chb-send-panel__loader"></div>
                                    </div>
                                </fieldset>
                                <button class="chb-send-panel__btn js-chb-send-btn" disabled type="button">Send</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </div>

    <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
    <script type="text/javascript" src="{$base_uri}/prox-modules/chatbot/js/runtime.js?ver={$system_version}"></script>
    <script type="text/javascript" src="{$base_uri}/prox-modules/chatbot/js/main.js?ver={$system_version}"></script>
    <script type="text/javascript" src="{$base_uri}/prox-modules/chatbot/js/chatbot.js?ver={$system_version}"></script>

    <script type="text/javascript">
    var chatbotOrderUrl = '{$chatBotOrderUrl}';

    setTimeout(function() {
        var chatBot = new ChatBot.ChatEngine({
            isUserAuthorised: {$isUserAuthorised},
            isEasyBidding: true,
            orderUrl: '{$chatBotOrderUrl}',
            scripts: [
                {
                    inputType: 'topicDescr',
                    defaultValue: '',
                    questions: [{
                        id: 'default',
                        items: [
                            '👋 Hi, I’m your smart assistant Amy',
                            'I’ll help you with your writing task. Let’s find out what topic you’re working on.',
                            'Type the title or explain your topic to me.'
                        ]
                    }],
                    isAllowedForLoggedUser: true
                },
                {
                    inputType: 'pageCount',
                    defaultValue: '2',
                    questions: [{
                        id: 'default',
                        items: [
                            'Alright, and how many pages do you need?',
                            'Other students usually need 2-3 pages. Select the required number here.'
                        ]
                    }],
                    isAllowedForLoggedUser: true
                },
                {
                    inputType: 'orderDeadline',
                    values: {json_encode($tarrifsIds) nofilter},
                    defaultValue: '{$tarrifsIds[0]['name']}',
                    questions: [{
                        id: 'default',
                        items: [
                            'Is there a deadline for your task to be completed?'
                        ]
                    }],
                    isAllowedForLoggedUser: true
                },
                {
                    inputType: 'fileUpload',
                    questions: [{
                        id: 'default',
                        items: [
                            'Great! 👍 And before we proceed maybe you want to share some additional details on your task or add some files with instructions?',
                            'The more details you provide the easier for me to select you a perfect writer.'
                        ]
                    }],
                    isAllowedForLoggedUser: true
                },
                {
                    inputType: 'writerQuality',
                    defaultValue: '',
                    questions: [{
                        id: 'default',
                        items: [
                            'Almost there, who would you like to work on your paper?',
                            'You are able to choose from the three options provided. For Standard we assign any writer who is available for your assignment at the moment.'
                        ]
                    }],
                    isAllowedForLoggedUser: true
                },
                {
                    inputType: 'emailAddress',
                    questions: [{
                        id: 'default',
                        items: [
                            'Fantastic! 👍  One final step, please provide me your email address.'
                        ]
                    }],
                    isAllowedForLoggedUser: false
                },
                {
                    inputType: 'submitCO',
                    questions: [{
                        id: 'default',
                        items: [
                            'Yoohoo!🎉 You’re all set now and I‘m happy to transfer your task to the best match from our writers’ pool.',

                        ]
                    }],
                    isAllowedForLoggedUser: true
                }
            ],
            listOfType: 'subjects',
            uploaderParams: {
                upload_url: '{$base_uri}/api/v1/files',
                max_file_size: 32,
                attache_file: {
                    file_tpl: '    <div class=\"dz-preview dz-file-preview js_chatbot_div attached\"><div class=\"dz-details\"><div class=\"dz-filename\"><span data-dz-name class=\"js_chatbot_file_name\"></span></div><img data-dz-thumbnail /></div><div class=\"dz-progress\"><span class=\"dz-upload\" data-dz-uploadprogress></span></div><div class=\"dz-success-mark\"><span>✔</span></div><div class=\"dz-error-mark\><span>✘</span></div><div class=\"dz-error-message\"><span data-dz-errormessage></span></div></div>',
                    remove_tpl: '    <a class=\"dz-remove js_chatbot_uploader_remove\" data-dz-remove href=\"javascript:undefined;\"><i class=\"delete\"></i></a>',
                    upload_button_tpl: '    <button type=\"button\" class=\"chb-dropzone-popup__btn chb-dropzone-popup__btn_upload  dropzone-click trigger-dropzone dz-clickable\">Attach Files</button>',
                },
            },
            currencySign: '$',
        });

        chatBot.startBot();
    }, 1500)
    </script>

</body>
</html>