<?php
/**
 * CustomerApi
 * PHP version 5
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * CyberSource Merged Spec
 *
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace CyberSource\Api;

use \CyberSource\ApiClient;
use \CyberSource\ApiException;
use \CyberSource\Configuration;
use \CyberSource\ObjectSerializer;

/**
 * CustomerApi Class Doc Comment
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerApi
{
    /**
     * API Client
     *
     * @var \CyberSource\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \CyberSource\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\CyberSource\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \CyberSource\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \CyberSource\ApiClient $apiClient set the API client
     *
     * @return CustomerApi
     */
    public function setApiClient(\CyberSource\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation deleteCustomer
     *
     * Delete a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of void, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteCustomer($customerTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->deleteCustomerWithHttpInfo($customerTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation deleteCustomerWithHttpInfo
     *
     * Delete a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteCustomerWithHttpInfo($customerTokenId, $profileId = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling deleteCustomer');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.deleteCustomer, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.deleteCustomer, must be bigger than or equal to 1.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.deleteCustomer, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.deleteCustomer, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/tms/v2/customers/{customerTokenId}'
            );

            return [$response, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getCustomer
     *
     * Retrieve a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomer($customerTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->getCustomerWithHttpInfo($customerTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getCustomerWithHttpInfo
     *
     * Retrieve a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomerWithHttpInfo($customerTokenId, $profileId = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling getCustomer');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.getCustomer, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.getCustomer, must be bigger than or equal to 1.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.getCustomer, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.getCustomer, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\TmsV2CustomersResponse',
                '/tms/v2/customers/{customerTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\TmsV2CustomersResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\TmsV2CustomersResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation patchCustomer
     *
     * Update a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param \CyberSource\Model\PatchCustomerRequest $patchCustomerRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchCustomer($customerTokenId, $patchCustomerRequest, $profileId = null, $ifMatch = null)
    {
        list($response, $statusCode, $httpHeader) = $this->patchCustomerWithHttpInfo($customerTokenId, $patchCustomerRequest, $profileId, $ifMatch);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation patchCustomerWithHttpInfo
     *
     * Update a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param \CyberSource\Model\PatchCustomerRequest $patchCustomerRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchCustomerWithHttpInfo($customerTokenId, $patchCustomerRequest, $profileId = null, $ifMatch = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling patchCustomer');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.patchCustomer, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerApi.patchCustomer, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'patchCustomerRequest' is set
        if ($patchCustomerRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $patchCustomerRequest when calling patchCustomer');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.patchCustomer, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.patchCustomer, must be bigger than or equal to 36.');
        }

        if (!is_null($ifMatch) && (strlen($ifMatch) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling CustomerApi.patchCustomer, must be smaller than or equal to 32.');
        }
        if (!is_null($ifMatch) && (strlen($ifMatch) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling CustomerApi.patchCustomer, must be bigger than or equal to 1.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // header params
        if ($ifMatch !== null) {
            $headerParams['if-match'] = $this->apiClient->getSerializer()->toHeaderValue($ifMatch);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($patchCustomerRequest)) {
            $_tempBody = $patchCustomerRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PATCH',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\TmsV2CustomersResponse',
                '/tms/v2/customers/{customerTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\TmsV2CustomersResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\TmsV2CustomersResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 412:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation postCustomer
     *
     * Create a Customer
     *
     * @param \CyberSource\Model\PostCustomerRequest $postCustomerRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function postCustomer($postCustomerRequest, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->postCustomerWithHttpInfo($postCustomerRequest, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation postCustomerWithHttpInfo
     *
     * Create a Customer
     *
     * @param \CyberSource\Model\PostCustomerRequest $postCustomerRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\TmsV2CustomersResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function postCustomerWithHttpInfo($postCustomerRequest, $profileId = null)
    {
        // verify the required parameter 'postCustomerRequest' is set
        if ($postCustomerRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $postCustomerRequest when calling postCustomer');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.postCustomer, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerApi.postCustomer, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // body params
        $_tempBody = null;
        if (isset($postCustomerRequest)) {
            $_tempBody = $postCustomerRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\TmsV2CustomersResponse',
                '/tms/v2/customers'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\TmsV2CustomersResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\TmsV2CustomersResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
