<style>
.table {
    width: 100%;
    padding: 10px 30px 0;
}
.table th {
    text-align: right;
}
</style>
<div class="form-container">
    <div id="payment-form">
        <div class="form-header">
            <h1 class="Header-companyName">{$siteName}</h1>
            <h2 class="Header-purchaseDescription">{$title}</h2>
        </div>
        {if isset($orderServices['servicesById']) && $order.tax > 0}
            <table class="table">
                <tbody> 
                    {foreach from=$orderServices['servicesById'] key=$serviceId item=$serviceById}
                        {if isset($serviceById.active) && $serviceById.active}
                            <tr>
                                <td>{$serviceById.title}</td>
                                <th scope="row">
                                    <span class="text-success">{formatPrice($serviceById.cost, $currencyOptions)}</span>
                                </th>
                            </tr>
                        {/if}
                    {/foreach}

                    {if $order.tax}
                        <tr>
                            <td>Tax</td>
                            <th scope="row">
                                <span class="text-success">{formatPrice($order.tax, $currencyOptions)}</span>
                            </th>
                        </tr>
                    {/if}
                <tbody> 
            </table>
        {/if}
        <div class="form-body">
            <div class="js_loader flat-spinner" style="display:none;"></div>
            <div id="paypal-button-container"></div>
            <a class="back_to_order" href="/dashboard/order/{$order.id}">Back to Order</a>
        </div>
    </div> 
</div> 

<script
    src="https://www.paypal.com/sdk/js?client-id={$paypal_client}&currency={$currency}">
</script>

<script type="text/javascript">
    paypal.Buttons({
        createOrder: function(data, actions) {
            return actions.order.create({
                purchase_units: [{
                    amount: {
                        value: '{$amount}' 
                    },
                }],
                application_context: {
                    shipping_preference: 'NO_SHIPPING',
                }
            });
        },
        onApprove: function(data, actions) {
            return actions.order.capture().then(function(payment) {
                $('#paypal-button-container').hide();
                $('.js_loader').show();
                $.ajax({
                    method: "POST",
                    url: '{$callback_url nofilter}',
                    data: { 
                        handle: 'order',
                        nodeId: '{$order.id}',
                        currency: '{$currency}',
                        tax: '{$order.tax|floatval}',
                        payment_method: '{$payment_method}',
                        paymentId: payment.id,
                        payerId: payment.payer.payer_id
                    }
                })
                .done(function(response) {
                    if(response.success) {
                        window.location = '{$success_url nofilter}';
                    } else {
                        window.location = '{$decline_url nofilter}';
                    }
                });
            });
        }
    }).render('#paypal-button-container');
</script>