// button status
function button_status(element, handle) {
    if(handle == "loading") {
        /* loading */
        element.data('text', element.html());
        element.prop('disabled', true);
        element.html('<span class="spinner-grow spinner-grow-sm mr10"></span>Loading');
    } else {
        /* reset */
        element.prop('disabled', false);
        element.html(element.data('text'));
    }
}

/* 2Checkout */
$(document).on('submit', '#payment-form', function (e) {
    e.preventDefault();
    TCO.loadPubKey("production", function() {
        twocheckout_token_request();
    });
    return false;
});

function twocheckout_token_request() {
    var form = $("#payment-form");
    var submit =  form.find('button[type="submit"]');
    var error =  form.find('.alert.alert-danger');
    button_status(submit, "loading");
    if (form.find('input[name="card_number"]').val() != '' && form.find('input[select="card_exp_month"]').val() != '' && form.find('select[name="card_exp_year"]').val() != '' && form.find('input[name="card_cvv"]').val() != '' && form.find('input[name="billing_name"]').val() != '' && form.find('input[name="billing_email"]').val() != '' && form.find('input[name="billing_phone"]').val() != '' && form.find('input[name="billing_address"]').val() != '' && form.find('input[name="billing_city"]').val() != '' && form.find('input[name="billing_state"]').val() != '' && form.find('select[name="billing_country"]').val() != '' && form.find('input[name="billing_zip_code"]').val() != '') {
        /* setup token request arguments */
        var args = {
            sellerId: twocheckout_merchant_code,
            publishableKey: twocheckout_publishable_key,
            ccNo: form.find('input[name="card_number"]').val(),
            cvv: form.find('input[name="card_cvv"]').val(),
            expMonth: form.find('select[name="card_exp_month"]').val(),
            expYear: form.find('select[name="card_exp_year"]').val()
        };
        /* make the token request */
        TCO.requestToken(twocheckout_success_callback, twocheckout_error_callback, args);
    } else {
        button_status(submit, "reset");
        error.html('You must fill in all of the fields').slideDown();
    }
};

function twocheckout_success_callback(data) {
    var form = $("#payment-form");
    var submit =  form.find('button[type="submit"]');
    var error =  form.find('.alert.alert-danger');
    /* update token */
    form.find('input[name="token"]').val(data.response.token.token);
    /* get ajax response */
    $.post(twocheckout_api_url, form.serialize(), function(response) {
        /* button reset */
        button_status(submit, "reset");
        /* handle response */
        if(response.error) {
            error.html(response.message).slideDown();
        } else {
            eval(response.callback);
        }
    }, "json")
    .fail(function() {
        /* button reset */
        button_status(submit, "reset");
        /* handle error */
        error.html('There is something that went wrong!').slideDown();
    });
};

function twocheckout_error_callback(data) {
    var form = $("#payment-form");
    var submit =  form.find('button[type="submit"]');
    var error =  form.find('.alert.alert-danger');
    if (data.errorCode === 200) {
        twocheckout_token_request();
    } else {
        button_status(submit, "reset");
        error.html(data.errorMsg).slideDown();
    }
};