module.exports = (env, argv) => {

    const path = require('path');
    const mode = argv.mode || 'production';

    return {
        mode: mode,
        entry: [
            './js/index.js'
        ],
        output: {
            path: path.resolve(__dirname, '../wp'),
            filename: 'header.js'
        },
        module: {
            rules: [
                {
                    test: /\.js$/,
                    use: {
                        loader: 'babel-loader',
                        options: {
                            presets: ['@babel/preset-env']
                        }
                    },
                },
            ]
        },
        externals: {
            Proxim: 'Proxim'
        },
        devtool: 'source-map'
    };
};
